---
title: will-change
slug: Web/CSS/will-change
tags:
  - CSS
  - CSS Property
  - CSS Will-change
  - Performance
  - Reference
  - Transitions
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <strong><code>will-change</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property hints to browsers how an element is expected to change. Browsers may set up optimizations before an element is actually changed.</span> These kinds of optimizations can increase the responsiveness of a page by doing potentially expensive work before they are actually required.</p>

<div class="warning">
<p><strong>Important:</strong> <code>will-change</code> is intended to be used as a last resort, in order to try to deal with existing performance problems. It should not be used to anticipate performance problems.</p>
</div>

<pre class="brush:css no-line-numbers notranslate">/* Keyword values */
will-change: auto;
will-change: scroll-position;
will-change: contents;
will-change: transform;        /* Example of &lt;custom-ident&gt; */
will-change: opacity;          /* Example of &lt;custom-ident&gt; */
will-change: left, top;        /* Example of two &lt;animateable-feature&gt; */

/* Global values */
will-change: inherit;
will-change: initial;
will-change: unset;
</pre>

<p>Proper usage of this property can be a bit tricky:</p>

<ul>
 <li>
  <p id="Don't_apply_will-change_to_too_many_elements"><em>Don't apply will-change to too many elements.</em> The browser already tries as hard as it can to optimize everything. Some of the stronger optimizations that are likely to be tied to <code>will-change</code> end up using a lot of a machine’s resources, and when overused like this can cause the page to slow down or consume a lot of resources.</p>
 </li>
 <li>
  <p><em>Use sparingly.</em> The normal behavior for optimizations that the browser make is to remove the optimizations as soon as it can and revert back to normal. But adding <code>will-change</code> directly in a stylesheet implies that the targeted elements are always a few moments away from changing and the browser will keep the optimizations for much longer time than it would have otherwise. So it is a good practice to switch <code>will-change</code> on and off using script code before and after the change occurs.</p>
 </li>
 <li>
  <p><em>Don't apply will-change to elements to perform premature optimization</em>. If your page is performing well, don't add the <code>will-change</code> property to elements just to wring out a little more speed. <code>will-change</code> is intended to be used as something of a last resort, in order to try to deal with existing performance problems. It should not be used to anticipate performance problems. Excessive use of <code>will-change</code> will result in excessive memory use and will cause more complex rendering to occur as the browser attempts to prepare for the possible change. This will lead to worse performance.</p>
 </li>
 <li>
  <p id="Give_it_sufficient_time_to_work"><em>Give it sufficient time to work</em>. This property is intended as a method for authors to let the user-agent know about properties that are likely to change ahead of time. Then the browser can choose to apply any ahead-of-time optimizations required for the property change before the property change actually happens. So it is important to give the browser some time to actually do the optimizations. Find some way to predict at least slightly ahead of time that something will change, and set <code>will-change</code> then.</p>
 </li>
 <li>
  <p><em>Be aware, that will-change may actually influence the visual appearance of elements</em>, when used with property values, that create a <a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/The_stacking_context">stacking context</a> (e.g. will-change: opacity), as the stacking context is created up front.</p>
 </li>
</ul>

<h2 id="Syntax">Syntax</h2>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>auto</code></dt>
 <dd>This keyword expresses no particular intent; the user agent should apply whatever heuristics and optimizations it normally does.</dd>
</dl>

<p>The <code>&lt;animateable-feature&gt;</code> can be one of the following values:</p>

<dl>
 <dt><code>scroll-position</code></dt>
 <dd>Indicates that the author expects to animate or change the scroll position of the element in the near future.</dd>
 <dt><code>contents</code></dt>
 <dd>Indicates that the author expects to animate or change something about the element’s contents in the near future.</dd>
 <dt>{{cssxref("custom-ident", "&lt;custom-ident&gt;")}}</dt>
 <dd>Indicates that the author expects to animate or change the property with the given name on the element in the near future. If the property given is a shorthand, it indicates the expectation for all the longhands the shorthand expands to. It cannot be one of the following values: <code>unset</code>, <code>initial</code>, <code>inherit</code>, <code>will-change</code>, <code>auto</code>, <code>scroll-position</code>, or <code>contents</code>. The spec doesn't define the behavior of particular value, but it is common for <code>transform</code> to be a compositing layer hint. <a href="https://github.com/operasoftware/devopera/pull/330">Chrome currently takes two actions</a>, given particular CSS property idents: establish a new compositing layer or a new {{Glossary("stacking context")}}.</dd>
</dl>

<h3 id="Via_stylesheet">Via stylesheet</h3>

<p>It may be appropriate to include <code>will-change</code> in your style sheet for an application that does page flips on key presses like an album or a slide deck presentation where the pages are large and complex. This will let browser prepare the transition ahead of time and allow for snappy transitions between the pages as soon as the key is pressed. But use caution with the <code>will-change</code> property directly in stylesheets. It may cause the browser to keep the optimization in memory for much longer than it is needed.</p>

<pre class="brush: css notranslate">.slide {
  will-change: transform;
}</pre>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Via_script">Via script</h3>

<p>This is an example showing how to apply the <code>will-change</code> property through scripting, which is probably what you should be doing in most cases.</p>

<pre class="brush: js notranslate">var el = document.getElementById('element');

// Set will-change when the element is hovered
el.addEventListener('mouseenter', hintBrowser);
el.addEventListener('animationEnd', removeHint);

function hintBrowser() {
  // The optimizable properties that are going to change
  // in the animation's keyframes block
  this.style.willChange = 'transform, opacity';
}

function removeHint() {
  this.style.willChange = 'auto';
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS Will Change', '#will-change', 'will-change')}}</td>
   <td>{{Spec2('CSS Will Change')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.will-change")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("transform")}}</li>
</ul>
